#ifndef _GLOBALS_H
#define _GLOBALS_H

/**
        ,    
  .
@memo   ,   
@name globals.h
@author (c) 2004-05 .. , .. 
@version \today
*/

#include "omegacfg.h"

/*@{*/

/**
    .
@memo  
@name globals.h_constants
@see globals.h_objects globals.h_types
*/

/*@{*/

/**
     .
@memo   
@name globals.h_constants_misc
@see globals.h_constants_reloperations
*/

/*@{*/

/**
      (, ) 
.
@memo  
@see TRUE FALSE
*/
#define NIL		(-1)

/**
@memo 
*/
#define TRUE	(1)

/**
@memo 
*/
#define FALSE	(0)

/*@}*/

/**
        .
@name globals.h_constants_reloperations
@memo    
*/

/*@{*/

/**
      JOIN ( ). 
          , 
   (. \Ref{JOIN_NESTEDLOOPS})      
 ,         (. \Ref{JOIN_MAINMEMORY}).
@memo   JOIN ( )
@see _JOIN_cargo_t JOIN_NESTEDLOOPS JOIN_MAINMEMORY JOIN_HASH JOIN_GRACE JOIN_MERGE RESTRICT SCAN 
*/
#define	JOIN		(1111)

/**
      RESTRICT ( ). 
@memo   RESTRICT ()
@see _RESTRICT_cargo_t SCAN JOIN 
*/
#define RESTRICT	(2222)

/**
      SCAN ( ). 
@memo   SCAN ()
@see _SCAN_cargo_t RESTRICT JOIN
*/
#define SCAN		(3333)

/*@}*/

/*@}*/

/**
     .
@memo   
@name globals.h_types
@see globals.h_constants globals.h_objects
*/

/*@{*/

/**
     : , ,  .
@memo , ,  
@name globals.h_types_relmodel
@see globals.h_types_treenode
*/

/*@{*/

/**
         {\bf long },
     (   
-EOF,       ).
@memo 
@see tupleptr_t ATTRIBUTES_IN_RELATION EOFtuple
*/
typedef long domain_t;

typedef domain_t tuple_t[ATTRIBUTES_IN_RELATION_MAX];

/**
        
  \Ref{ATTRIBUTES_IN_RELATION_MAX}    \Ref{domain_t}. 
@memo 
@see domain_t ATTRIBUTES_IN_RELATION_MAX
*/
typedef tuple_t _tuple_t; //    

/**
        .
@memo   
@see domain_t _tuple_t
*/
typedef domain_t * tupleptr_t;

typedef int (* fragment_fn_t)(tupleptr_t, int);

/**
  :
\begin{verbatim}
typedef int (* fragment_fn_t)(tupleptr_t, int);
\end{verbatim}
     :

\begin{tabular}{lll}
{\bf N / }	& {\bf 	} & {\bf  } \\
1		& \Ref{tupleptr_t}	&    \\
2		& int				&    
\end{tabular}

@memo    
@see tupleptr_t ATTRIBUTES_IN_RELATION
*/
typedef fragment_fn_t _fragment_fn_t; //    

/*@}*/

/**
          .
@name globals.h_types_relalgebra
@memo    
@see globals.h_types_relmodel globals.h_types_treenode
*/

/*@{*/

typedef struct {
	int attribute;
	void * supercargo;
} JOIN_cargo_t;

/**
 JOIN   :

\begin{tabular}{lll}
{\bf N /}	& {\bf }		& {\bf }	\\
1			& int attribute		&    \\
2			& void * supercargo	&        
\end{tabular}
@memo   JOIN
@see JOIN_NESTEDLOOPS JOIN_MAINMEMORY _RESTRICT_cargo_t _SCAN_cargo_t
*/
typedef JOIN_cargo_t _JOIN_cargo_t; //      

typedef enum {
	EQUAL				=0,
	NOT_EQUAL			=1,
	GREATER				=2,
	LESS				=3,
	GREATER_OR_EQUAL	=4,
	LESS_OR_EQUAL		=5
} theta_t; 

/**
   :

\begin{tabular}{cll}
{\bf N /}	& {\bf  }	& {\bf }	\\
1			&	EQUAL					&  \\
2			&	NOT_EQUAL				&    \\
3			&	GREATER					&   \\
4			&	LESS					&   \\
5			&	GREATER_OR_EQUAL		&    \\
6			&	LESS_OR_EQUAL			&   
\end{tabular}
@memo  
@see _RESTRICT_cargo_t
*/
typedef theta_t _theta_t; //      

typedef struct {
	int attribute;
	theta_t theta;
	domain_t literal;
} RESTRICT_cargo_t;

/**
 RESTRICT   :

\begin{tabular}{lll}
{\bf N /}	& {\bf }			& {\bf }	\\
1		& int attribute				&    \\
2		& \Ref{_theta_t} theta		&   \\
3		& \Ref{domain_t} literal	&   
\end{tabular}
@memo   RESTRICT
@see _theta_t domain_t
*/
typedef RESTRICT_cargo_t _RESTRICT_cargo_t; //      

typedef struct {
	int relation;
} SCAN_cargo_t;

/**
 SCAN   :

\begin{tabular}{lll}
{\bf N /}	& {\bf }		& {\bf }	\\
1			& int relation		&  -
\end{tabular}
@memo   SCAN
@see _JOIN_cargo_t _RESTRICT_cargo_t
*/
typedef SCAN_cargo_t _SCAN_cargo_t; //      

/**
        .
@name globals.h_types_relalgebra_macro
@memo     
@see globals.h_types_relalgebra
*/

/*@{*/

/**
          :
\begin{verbatim}
((JOIN_cargo_t *) treenode->cargo)->attr
\end{verbatim}
@memo     JOIN
@param treenode     
@param attr  
@see _JOIN_cargo_t RESTRICT_CARGO SCAN_CARGO
*/
#define JOIN_CARGO(treenode, attr)	((JOIN_cargo_t *) treenode->cargo)->attr

/**
          :
\begin{verbatim}
((RESTRICT_cargo_t *) treenode->cargo)->attr
\end{verbatim}
@memo     RESTRICT
@param treenode     
@param attr  
@see _RESTRICT_cargo_t JOIN_CARGO SCAN_CARGO
*/
#define RESTRICT_CARGO(treenode, attr)	((RESTRICT_cargo_t *) treenode->cargo)->attr

/**
          :
\begin{verbatim}
((SCAN_cargo_t *) treenode->cargo)->attr
\end{verbatim}
@memo     SCAN
@param treenode     
@param attr  
@see _SCAN_cargo_t JOIN_CARGO RESTRICT_CARGO
*/
#define SCAN_CARGO(treenode, attr)	((SCAN_cargo_t *) treenode->cargo)->attr

/*@}*/

/*@}*/

/**
     ,          
   : , , .
@memo    
@name  globals.h_types_treenode
@see globals.h_types_relmodel
*/

/*@{*/

typedef tupleptr_t (* next_fn_t)(void *);

/**
 :
\begin{verbatim}
typedef tupleptr_t (* next_fn_t)(void *);
\end{verbatim}
       . 
          
    ,   .
@memo      "NEXT"
@see _reset_fn_t _treenode_t tupleptr_t
*/
typedef next_fn_t _next_fn_t;

typedef void (* reset_fn_t)(void *);

/**
 :
\begin{verbatim}
typedef void (* reset_fn_t)(void *);
\end{verbatim}
       . 
  ,     .
@memo      "RESET"
@see _next_fn_t tupleptr_t _treenode_t
*/
typedef reset_fn_t _reset_fn_t;

typedef struct _treenode {
	int rel_operation;		//    
	int phys_operation;		//     
	void * cargo;			//   (     )
	int fragmentattr;		//        ,   
	fragment_fn_t fragmentfn;//        ,   
	int ary;				//  ( )     ,   
	next_fn_t nextfn;		//   ,   "NEXT"     
	reset_fn_t resetfn;		//   ,   "RESET"     
	tuple_t result;			// -    ,   
	int isBOF;				//  " " (    ,       )
	int isEOF;				//  " " (    ,       )
	struct _treenode * left;//    
	struct _treenode * right;//    
} treenode_t;

/**
     ,     
        : , 
, .      :

\begin{tabular}{lll}
{\bf N /}	& {\bf }						& {\bf }	\\
1			& int rel_operation;				&     \\
2			& int phys_operation;				&      \\
3			& void * cargo;						&   (     ) \\
4			& int fragmentattr;					&        ,    \\
5			& \Ref{_fragment_fn_t} fragmentfn;	&        ,    \\
6			& int ary;							&  ( )     ,    \\
7			& \Ref{_next_fn_t} nextfn;			&   ,   "NEXT"      \\
8			& \Ref{_reset_fn_t} resetfn;		&   ,   "RESET"      \\
9			& \Ref{tuple_t} result;				& -    ,    \\
10			& int isBOF;						&  " " (    ,       ) \\
11			& int isEOF;						&  " " (    ,       ) \\
12			& struct \Ref{_treenode_t} * left;	&     \\
13			& struct \Ref{_treenode_t} * right;	&    
\end{tabular}
@memo   
*/
typedef treenode_t _treenode_t;

/*@}*/

/*@}*/

/**
    .
@memo  
@name globals.h_objects
@see globals.h_constants globals.h_types
*/

/*@{*/

/**
           
 .
@memo    
@see FRAGMENTS_IN_RELATION WHOAMI
*/
extern int NODES_IN_CLUSTER;

/**
     .
@memo    
@see NODES_IN_CLUSTER
*/
#define FRAGMENTS_IN_RELATION (NODES_IN_CLUSTER)

/**
        .
@memo   
@see NODES_IN_CLUSTER
*/
extern int WHOAMI;

/**
    ,         
 .         
{\Ref en_ExecuteQuery}, ..            ,
       .
@memo   
@see en_ExecuteQuery
*/
extern double EXECTIME;

/*@}*/

/*@}*/

#endif // _GLOBALS_H